"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _helperPluginUtils() {
  var data = require("@babel/helper-plugin-utils");

  _helperPluginUtils = function _helperPluginUtils() {
    return data;
  };

  return data;
}

function _pluginSyntaxNullishCoalescingOperator() {
  var data = _interopRequireDefault(require("@babel/plugin-syntax-nullish-coalescing-operator"));

  _pluginSyntaxNullishCoalescingOperator = function _pluginSyntaxNullishCoalescingOperator() {
    return data;
  };

  return data;
}

function _core() {
  var data = require("@babel/core");

  _core = function _core() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (0, _helperPluginUtils().declare)(function (api, _ref) {
  var _ref$loose = _ref.loose,
      loose = _ref$loose === void 0 ? false : _ref$loose;
  api.assertVersion(7);
  return {
    inherits: _pluginSyntaxNullishCoalescingOperator().default,
    visitor: {
      LogicalExpression: function LogicalExpression(path) {
        var node = path.node,
            scope = path.scope;

        if (node.operator !== "??") {
          return;
        }

        var ref = scope.generateUidIdentifierBasedOnNode(node.left);
        scope.push({
          id: ref
        });

        var assignment = _core().types.assignmentExpression("=", _core().types.cloneNode(ref), node.left);

        path.replaceWith(_core().types.conditionalExpression(loose ? _core().types.binaryExpression("!=", assignment, _core().types.nullLiteral()) : _core().types.logicalExpression("&&", _core().types.binaryExpression("!==", assignment, _core().types.nullLiteral()), _core().types.binaryExpression("!==", _core().types.cloneNode(ref), scope.buildUndefinedNode())), _core().types.cloneNode(ref), node.right));
      }
    }
  };
});

exports.default = _default;